﻿Imports C1.WPF.Theming
Imports System.IO
Imports C1.WPF.C1Chart3D
Imports C1.WPF.Pdf
Imports Microsoft.Win32

Class MainWindow

    Private Sub Grid_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        System.Windows.Application.Current.Resources.MergedDictionaries.Add(C1Theme.GetCurrentThemeResources(New C1.WPF.Theming.BureauBlack.C1ThemeBureauBlack()))
    End Sub

    Private Sub PDF_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ' use size of visible chart
        Dim sz = New Size(chart.ActualWidth, chart.ActualHeight)

        Using file__1 = File.Open("chart.jpeg", FileMode.Create)
            chart.SaveImage(file__1, ImageFormat.Jpeg)
        End Using

        Dim doc As New C1PdfDocument()
        doc.Compression = CompressionLevel.BestCompression

        Dim img As BitmapSource = DirectCast(GetThumbnail(), BitmapSource)
        Dim wb As New WriteableBitmap(img)
        doc.DrawImage(wb, New Rect(New Point(), doc.PageSize), ContentAlignment.TopCenter, Stretch.Uniform)

        doc.NewPage()

        Dim sfd As New SaveFileDialog() With {
            .DefaultExt = "pdf",
            .Filter = "Pdf files (*.pdf)|*.pdf"}

        If sfd.ShowDialog() = True Then
            Using stream = sfd.OpenFile()
                doc.Save(stream)
            End Using
        End If

    End Sub

    Private Function GetThumbnail() As ImageSource
        Dim buffer As Byte() = File.ReadAllBytes("chart.jpeg")
        Dim memoryStream As New MemoryStream(buffer)

        Dim bitmap As New BitmapImage()
        bitmap.BeginInit()
        bitmap.StreamSource = memoryStream
        bitmap.EndInit()
        bitmap.Freeze()

        Return bitmap
    End Function

    Private Sub ColorPalette_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim list As IList(Of Color) = New List(Of Color)()
        'Add the colors as per your requirement  
        list.Add(Colors.DarkGreen)
        list.Add(Colors.DarkOrange)
        list.Add(Colors.DarkViolet)
        list.Add(Colors.HotPink)
        list.Add(Colors.BurlyWood)
        list.Add(Colors.MediumSpringGreen)
        chart.ColorPalette = list

    End Sub

    Private Sub Prn_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim dlg = New System.Windows.Controls.PrintDialog()
        If dlg.ShowDialog().Value Then
            dlg.PrintVisual(chart, "ComponentOne Chart3D for WPF")
        End If
    End Sub
End Class
